<template>
  <header
    class="appHeader _static"
    :class="{'__fixed': isCabinet}">
    <div
      class="appHeader-wrapper">
      <div
        v-if="!isCabinet && $config.siteWarning"
        class="stub-warning">
        <span v-html="$config.siteWarning"/>
      </div>
      <div class="appHeader-top container">
        <div class="appHeader-items">
          <div
            v-if="isCabinet"
            class="logo-cabinet">
            <flink
              href="/"
              domain="main"
              class="link">
              <span class="logo">
                <span class="logo-img">
                  <img
                    svg-inline
                    src="~/assets/svg/redesign/logo-main.svg">
                </span>
              </span>
            </flink>
          </div>
          <nav
            v-if="!isCabinet"
            class="appHeader-navigation">
            <flink
              href="/"
              domain="main"
              class="appHeader-navigation-item"
              :class="{'-active': navigation === 'parts'}"
              @click.native="$ga('Zap','Click18')">
              Запчасти
            </flink>
            <flink
              href="/"
              domain="sto"
              class="appHeader-navigation-item"
              :class="{'-active': domain === $config.domains.sto }"
              @click.native="$ga('STO','Click19')">
              Автотехцентры
            </flink>
            <flink
              href="/"
              domain="helper"
              class="appHeader-navigation-item"
              :class="{'-active': domain === $config.domains.helper }">
              Автоконсьерж
            </flink>
          </nav>
          <flink
            v-else
            href="/"
            class="button _transparent buttonBack">
            <img
              svg-inline
              src="~/assets/svg/redesign/button-arrow-right.svg">
            Вернуться на сайт
          </flink>
        </div>
        <div class="appHeader-items">
          <!--         Выбор валюты     -->
          <!-- Нет такого функционала -->
          <!--
          <AppSelectCurrency
            :options="currency"/>
          -->
          <AppButton
            :classes="['buttonLocation', '_none-round', '_transparent',]"
            @click.native="showLocationModal(); $ga('Contry','Click13'); $ym('search_city')">
            <span
              slot="button-item"
              class="button-item">
              <template v-if="!locationAutoDetected">
                <img
                  svg-inline
                  src="~/assets/svg/redesign/location.svg">
                <span class="button-label">{{ locationSelected ? location.name : 'Все страны' }}</span>
              </template>
              <template v-else>
                <AppPopover
                  v-if="locationSelected"
                  :options="tooltipLocationpOptions"
                  @apply-hide="disableAutoDetectLocation">
                  <span
                    slot="tooltip-trigger"
                    class="text">
                    <img
                      svg-inline
                      src="~/assets/svg/redesign/location.svg">
                    <span class="button-label">{{ location.name }}</span>
                  </span>
                  <template slot="tooltip-content">
                    <no-ssr>
                      <span class="tooltip-text">Ваш город {{ location.name }}?</span>
                      <button
                        class="button"
                        v-close-popover>Да
                      </button>
                      <button
                        class="button buttonOutline"
                        @click="showLocationModal()"
                        v-close-popover>Изменить
                      </button>
                    </no-ssr>
                  </template>
                </AppPopover>
                <AppPopover
                  v-else
                  :options="tooltipLocationpOptions"
                  :open="locationAutoDetected"
                  @apply-hide="onHideCityNotFoundTooltip">
                  <span
                    slot="tooltip-trigger"
                    class="text">
                    <img
                      svg-inline
                      src="~/assets/svg/redesign/location.svg">
                    <span class="button-label">Все страны</span>
                  </span>
                  <template slot="tooltip-content">
                    <no-ssr>
                      <div class="paragraph">Мы не смогли определить ваш город автоматически.</div>
                      <button
                        class="button buttonOutline"
                        @click="showLocationModal()"
                        v-close-popover>Выберите город
                      </button>
                    </no-ssr>
                  </template>
                </AppPopover>
              </template>
            </span>
          </AppButton>

          <!-- кнопка загрузки прайса -->
          <AddPriceButton
            :auth="auth"
            @showAuthModal="showAuthModal"/>

          <!-- Авторизированный пользователь -->
          <AppUserActions
            @login="login(); $ga('Enter','Click17'); $ym('enter')"
            @logout="logout"
            :auth="auth"/>


        </div>
      </div>
      <div
        class="menu container"
        v-scroll-lock="scrollable"
        :class="{'-open': hasOpenMenu, '_cabinet': isCabinet }">
        <div class="menu-items _left">
          <AppButton
            :classes="['burgerMenu', '_transparent', '_none-round']"
            @click.native="openMenuFixBody">
            <span
              slot="button-item"
              class="button-item">
              <img
                v-if="!hasOpenMenu"
                svg-inline
                src="assets/svg/redesign/burger.svg">
              <img
                v-if="hasOpenMenu"
                svg-inline
                src="assets/svg/redesign/cross-bold.svg">
            </span>
          </AppButton>
          <flink
            v-show="!hasOpenMenu"
            href="/"
            domain="main"
            class="link">
            <span class="logo">
              <span class="logo-img">
                <img
                  svg-inline
                  src="~/assets/svg/redesign/logo-main.svg">
              </span>
              <span class="logo-caption">Найдётся всё для вашего авто</span>
            </span>
          </flink>
          <button
            v-if="hasOpenMenu"
            @click="showLocationModal()"
            class="button _transparent buttonLocation">
            <template v-if="!locationAutoDetected">
              <img
                svg-inline
                src="~/assets/svg/redesign/location-mobile.svg">
              <span>{{ locationSelected ? location.name : 'Все страны' }}</span>
            </template>
            <template v-else>
              <span>
                <img
                  svg-inline
                  src="~/assets/svg/redesign/location-mobile.svg">
                <span class="button-label">{{ location.name }}</span>
              </span>
            </template>
          </button>
        </div>
        <div
          class="menu-items _right">
          <nav
            class="appHeader-navigation _tabs"
            v-show="hasOpenMenu">
            <flink
              href="/"
              domain="main"
              class="appHeader-navigation-item"
              :class="{'-active': navigation === 'parts'}"
              @click.native="$ga('Zap','Click18')">
              <img
                svg-inline
                src="~/assets/svg/redesign/navigation-parts.svg">
              Запчасти
            </flink>
            <flink
              href="/"
              domain="sto"
              class="appHeader-navigation-item"
              :class="{'-active': domain === $config.domains.sto }"
              @click.native="$ga('STO','Click19')">
              <img
                svg-inline
                src="~/assets/svg/redesign/navigation-sto.svg">
              Автотехцентры
            </flink>
            <flink
              href="/"
              domain="helper"
              class="appHeader-navigation-item"
              :class="{'-active': domain === $config.domains.helper }">
              <img
                svg-inline
                src="~/assets/svg/redesign/navigation-concierge.svg">
              Автоконсьерж
            </flink>
          </nav>
          <ul
            v-if="sections"
            class="menu-grid"
            :class="{'_column': hasOpenMenu}">
            <!-- @todo проверить работу функционала-->
            <!-- до этого в некоторых пунктах меню active-class проставлялся через  -->
            <!-- :class="{ active: $route.path.startsWith('/wheels') }" -->
            <!-- или -->
            <!-- :class="{ active: $route.path.startsWith('/faq/') }" -->
            <template v-for="(section, index) in sections">
              <li
                v-if="!isSparePartsCatalogs(section)"
                class="menu-grid-item"
                :key="index"
                :class="{'_categories': isPartsCategories(section)}">
                <flink
                  :href="section.href"
                  :active-class="isActiveClassSection(section)"
                  exact-active-class="-active"
                  :domain="section.domain"
                  :class="{'-active': isActive(section)}"
                  @click.native.prevent="disableFixBody">
                  <span class="menu-section">
                    {{ section.title }}
                  </span>
                </flink>
              </li>
              <li
                v-else
                :key="index"
                v-click-outside="onClickOutsideHeaderSubmenu"
                class="menu-grid-item _catalogs">
                <span
                  @click="toggleHeaderSubMenuShow(section)"
                  class="menu-section"
                  :class="{'-active': isActive(section)}">
                  {{ section.title }}
                  <img
                    svg-inline
                    src="~/assets/svg/redesign/button-arrow-down-small.svg">
                </span>
                <PartsCatalogs :class="{ '-opened': isHeaderSubmenuOpened }"/>
              </li>
            </template>
          </ul>
          <!--          TODO: Скрыли пока нет страницы корзины-->
          <!--          <AppCart :cart="cart"/>-->
          <footer
            class="menu-footer"
            v-show="hasOpenMenu">

            <!-- кнопка загрузки прайса -->
            <!--<AddPriceButton
              :auth="auth"
              @showAuthModal="showAuthModal"/>-->

            <div class="menu-footer-options">
              <!--         Выбор валюты     -->
              <!-- Нет такого функционала -->
              <!--
              <AppButton
                :classes="['_none-round', '_transparent', 'buttonLogin', '__fluid']"
                @click.native="login(); $ga('Enter','Click17'); $ym('enter')">
                <span
                  slot="button-item"
                  class="button-item">
                  RUB
                </span>
              </AppButton>
              -->
              <!--
              <AppButton
                :classes="['_none-round', '_transparent', 'buttonLogin', '__fluid']"
                @click.native="login(); $ga('Enter','Click17'); $ym('enter')">
                <span
                  slot="button-item"
                  class="button-item">
                  {{ (auth && auth.username) || 'Войти1' }}
                </span>
              </AppButton>
              -->
              <AppUserActions
                @login="login(); $ga('Enter','Click17'); $ym('enter')"
                @logout="logout"
                container=".menu-footer-options .userActionsTrigger"
                :auth="auth"/>
            </div>
          </footer>
        </div>
      </div>
    </div>
  </header>
</template>

<script>
import Header from '~/assets/js/mixins/redesign/header';
import AppButton from '../../app-buttons/app-button';

export default {
  name: 'HeaderStatic',
  components: { AppButton },
  mixins: [Header],
  props: {
    isCabinet: {
      type: Boolean,
      default: false,
    },
  },
};
</script>

<style lang="postcss">
  .appHeader._static {
    .stub-warning {
      display: flex;
      justify-content: center;
      align-items: center;
      height: 40px;
      font-family: var(--font-heading);
      color: #fff;
      background-color: #f26a3f;
    }

    position: relative;
    z-index: var(--z-index-under-modal);

    .appHeader-items {
      display: inline-flex;
      height: 100%;

      .button {
        font-size: 0.75rem;
        font-weight: var(--font-weight-regular);
      }

      .button._transparent {
        color: var(--header-link-color);

        .button-label {
          display: inline-flex;
          max-width: 15rem;
          white-space: nowrap;
          overflow: hidden;
          transition: none;
        }

        &:hover {
          color: var(--header-link-hover-color);
        }

        &:active, &:focus {
          color: var(--bg-main);
        }

        &.buttonBack {
          margin-left: 1.5rem;
          .svg.svgArrowRight {
            display: block;
            margin-right: .5rem;
            width: .3125rem;
            height: auto;
            transform: rotate(180deg);
            fill: var(--header-link-color);
          }
          &:hover {
            .svg.svgArrowRight {
              fill: var(--header-link-hover-color);
            }
          }

          &:active, &:focus {
            .svg.svgArrowRight {
              fill: var(--bg-main);
            }
          }
        }
        &.buttonLogin {
          justify-content: flex-end;
          padding-left: 1.5rem;
          padding-right: 0;
        }

        &.buttonLocation {
          position: relative;
          padding-right: 1.5rem;
          .svg.svgLocation {
            position: absolute;
            top: 50%;
            left: -0.25rem;
            display: block;
            margin-top: -0.5rem;
            width: 0.875rem;
            height: auto;
            stroke: var(--header-link-color);
            fill: none;
            transition: stroke .1s var(--transition-easeOutQuad);
          }

          &:hover {
            .svg {
              stroke: var(--header-link-hover-color);
            }
          }

          &:active, &:focus {
            .svg {
              stroke: var(--bg-main);
            }
          }
        }
      }
    }

    .appHeader-top {
      display: flex;
      justify-content: space-between;
      align-items: center;
      width: 100%;
      height: 2.375rem;
      background-image:
        url("~assets/svg/redesign/bg-header.jpg"),
        linear-gradient(135deg, rgba(17,65,89,1) 0%,rgba(10,92,125,1) 51%,rgba(16,125,163,1) 100%);
      background-repeat: no-repeat;
      background-position: top center;
    }

    .appHeader-navigation {
      display: flex;
      padding: 0 1px;
      height: 100%;
      background-color: var(--header-button-bg);

      &._tabs {
        padding: 0;
        width: 100%;
        border-top: 1px solid var(--border-color-main);
        border-bottom: 1px solid var(--border-color-main);
        background-color: transparent;

        & .appHeader-navigation-item {
          display: flex;
          flex-direction: column;
          align-items: center;
          justify-content: center;
          padding: 0 1.25rem;
          width: 33.333%;
          height: 5.5rem;
          font-size: 0.75rem;
          color: var(--color-main);

          &.-active {
            background-color: var(--btn-bg);
          }

          .svg {
            flex-shrink: 0;
            display: block;
            margin-bottom: 0.5rem;
            width: 2.375rem;
            height: auto;
            fill: var(--color-main);
          }
        }
      }
    }

    .appHeader-navigation-item {
      display: inline-flex;
      align-items: center;
      padding: 0 1.5rem;
      font-size: 0.75rem;
      color: var(--bg-main);
      background-color: transparent;
      text-decoration: none;

      &:hover {
        opacity: 0.8;
      }

      &:active, &:focus {
        opacity: 0.75;
      }

      &.-active {
        color: var(--color-main);
        background-color: var(--bg-main);

        &:hover, &:active, &:focus {
          opacity: 1;
        }
      }
    }

    .burgerMenu {
      display: none;
    }

    .buttonAddItem {
     height: auto;
    }

    .menu {
      position: relative;
      display: flex;
      justify-content: space-between;
      border-bottom: 1px solid var(--border-color-light);
      background-color: var(--bg-main);

      .partsCatalogs {
        display: none;
      }
    }

    .menu-items {
      display: flex;
      align-items: center;

      &._right {
        width: 100%;
      }

      &.left {
        > .link {
          height: 100%;
        }
      }
    }

    .menu-grid {
      display: flex;
      align-items: center;
      justify-content: center;
      width: 100%;
      /* padding-left: 3.375rem; */
      padding-right: 11rem;


      &._column {
        flex-direction: column;
        /* padding-left: 0; */
        @media only screen and ( max-width: 980px ) {
          padding-right: 0;
        }

        .menu-grid-item {
          width: 100%;
        }

        .menu-section {
          margin-bottom: 0;
          padding-top: 1.375rem;
          padding-bottom: 1.375rem;
          width: 100%;
          font-size: 0.875rem;
          font-weight: var(--font-weight-medium);
          border-bottom: 1px solid var(--border-color-main);
        }
      }

      .-active {
        .menu-section {
          font-weight: var(--font-weight-medium);
          &::after {
            background-color: var(--header-nav-active-border);
            visibility: visible;
            @media only screen and ( max-width: 980px ) {
              visibility: hidden;
            }
          }
        }
      }
    }

    .menu-grid-item._catalogs {
      cursor: pointer;

      .active {
        .menu-section {
          font-weight: var(--font-weight-medium);
          &::after {
            background-color: var(--header-nav-active-border);
            visibility: visible;
            @media only screen and ( max-width: 980px ) {
              visibility: hidden;
            }
          }
        }
      }

      & .partsCatalogs.-opened {
        display: block;
      }
    }


    .menu-section {
      position: relative;
      display: flex;
      align-items: center;
      margin-bottom: -1px;
      padding: 0.98rem 1.25rem 0.8331rem;
      font-size: 0.875rem;
      color: var(--color-main);
      transition: color .3s var(--transition-easeOutQuad);

      &::after {
        content: '';
        position: absolute;
        bottom: 0;
        left: 0;
        height: 0.125rem;
        width: 100%;
        background-color: transparent;
        visibility: hidden;
        transition: background-color .3s var(--transition-easeOutQuad), visibility .3s var(--transition-easeOutQuad);
      }

      &:active {
        color: var(--link-dark-active-color);
      }

      &:hover, &:focus {
        color: var(--link-dark-hover-color);

        & > .svg {
          fill: var(--link-dark-hover-color);
        }
      }

      & > .svg {
        margin-left: 0.375rem;
        transition: fill .3s var(--transition-easeOutQuad);
      }

      &.-active {
        font-weight: var(--font-weight-bold);

        &:hover, &:active, &:focus {
          color: var(--color-main);
        }

        &::after {
          background-color: var(--header-nav-active-border);
          visibility: visible;
        }

        & > .svg {
          fill: var(--color-main);
          transition: fill .3s var(--transition-easeOutQuad);
        }
      }
    }

    .menu.-open {
      position: absolute;
      top: 0;
      bottom: 0;
      flex-direction: column;
      justify-content: flex-start;
      height: 100vh;
      width: 100vw;
      .menu-items._right {
        flex-direction: column;
        flex-shrink: 1;
        width: 100%;
        height: calc(100% - 4.375rem);
        visibility: visible;
        @supports (-webkit-overflow-scrolling: touch) { /* IOS DEVICES */
          display: block;
        }
      }

      .appHeader-navigation {
        height: auto;
      }
    }

    .search {
      padding-top: 1rem;
      padding-bottom: 1rem;
      text-align: center;
    }

    .menu-footer {
      display: flex;
      align-items: center;
      justify-content: center;
      flex-direction: column;
      flex-shrink: 0;
      width: 100%;
      min-height: 4rem;
      margin-top: auto;
      padding: 0.5rem 1.125rem calc(0.5rem + var(--mobile-browser-bar));
      background-color: var(--bg-darktset);
      @media only screen and ( max-width: 980px ) {
        @supports (-webkit-overflow-scrolling: touch) { /* IOS DEVICES */
          // padding-top: 1.625rem;
          // padding-bottom: 0;
          // justify-content: flex-start;
          // margin-top: 0;
          // flex-shrink: 1;
          // height: 6.875rem;
        }
      }

      .buttonAddItem {
        margin-bottom: 1.25rem;
        height: var(--btn-mobile-min-height);
        width: calc(100vw - 2.5rem);
        font-size: 1.125rem;
        border-radius: 0.25rem;
      }

      .menu-footer-options {
        display: flex;
        align-items: center;
        justify-content: center;
        width: 100%;

        .buttonLogin {
          padding: 0;
          min-height: 3rem;
          font-size: 1.125rem;
          color: var(--bg-main);
          @media only screen and ( max-width: 980px ) {
            @supports (-webkit-overflow-scrolling: touch) { /* IOS DEVICES */
              min-height: auto;
            }
          }
        }
      }
    }

    @media screen and (min-width: 981px) {
      .menu._cabinet {

        & .menu-grid,
        & .menu-items._left {
          display: none;
        }
      }

      .menu {
        & .menu-grid-item._categories {
          display: none;
        }
      }
    }

    @media screen and (max-width: 1200px) and (min-width: 981px) {
      .logo {
        flex-direction: column;
        justify-content: center;
      }

      .logo-img {
        padding-right: 0;
        padding-bottom: 0.5rem;
      }

      .menu-grid {
        padding-left: 0;
        padding-right: 0;
      }

      .menu-section {
        padding: 0.925rem .875rem;
      }
    }

    @media screen and (max-width: 980px) {
      .stub-warning {
        padding-left: 20px;
        padding-right: 20px;
        height: 50px;
        font-size: 12px;
      }

      .appHeader-top {
        display: none;
        .user-actions-popover-wrapper {
          display: none;
        }
      }

      .burgerMenu {
        display: inline-block;
        padding: 0 0.875rem;
        width: auto;
        height: 100%;
      }

      .logo {
        &-img {
          padding-right: 0;

          > .svg {
            width: 5.838rem;
            height: 1.025rem;
          }
        }

      }

      .menu.container {
        padding: 0;
        max-height: 100vh;
        overflow-y: auto;
        overflow-x: hidden;
      }

      .menu {
        border: none;

        .menu-items._left {
          flex-shrink: 0;
          padding: 0 0.375rem;
          height: 4.375rem;

          .link {
            height: 100%;
          }

          .button.buttonLocation {
            margin-left: auto;
            max-width: calc(100vw - 7rem);
            font-size: 1.125rem;
            text-align: left;
            color: var(--color-main-lightest);
            .svg {
              flex-shrink: 0;
              margin-right: 0.625rem;
            }
          }
        }

        .menu-items._right {
          width: 0;
          height: 0;
          visibility: hidden;
        }

        .menu-grid-item._catalogs {
          display: none;
          .menu-section {
            display: none;
          }
        }

        .partsCatalogs {
          position: static;
          display: block;
        }
      }

      .link.appCart {
        padding: 2rem 1.125rem 2.75rem 1.125rem;
        width: 100%;
      }
    }
  }

  /*Alex Czech НЕ ТРОГАТЬ - ВРЕМЕННЫЙ КОСТЫЛЬ*/
  .__fixed {
    position: fixed!important;
    width: 100%;
  }

  /*Alex Czech НЕ ТРОГАТЬ - ВРЕМЕННЫЙ КОСТЫЛЬ*/
  /*В итоге для ЛК нужен отдельный компонент header*/
  .logo-cabinet {
    display: flex;
    align-items: center;
    margin-right: 19px;

    & .logo-img {
      padding-bottom: 0;

      & > svg {
        height: 18px;

        & > .svgAuto {
          fill: var(--bg-main);
        }
      }
    }
  }
</style>
